package org.example;

import com.fasterxml.jackson.databind.JsonNode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import redis.clients.jedis.HostAndPort;
import redis.clients.jedis.JedisPooled;

import java.io.IOException;
import java.security.GeneralSecurityException;

@Service
public class LoadGameService
{
    @Autowired
    private RedisService redisService;


    public void loadGamesbySingleThread() throws InterruptedException
    {
        try (JedisPooled jedis = new JedisPooled(new HostAndPort(SteamConstants.REDIS_HOST, 6380), redisService.prepareRedisConfig()))
        {

            JsonNode json;
            int i = 0;
            while (i < 150000)
            {
                try
                {
                    json = redisService.loadGameJson(String.format(SteamConstants.GAME_DETAILS_API_TEMPLATE, i, "KZ"));
                }
                catch (IOException e)
                {
                    //TODO: add pushing logs to kibana or etc..
                    e.printStackTrace();
                    if (e.getMessage().equals("429"))
                    {
                        Thread.sleep(30000);
                        continue;
                    }
                    i++;
                    continue;

                }
                //TODO: add filter for successful and unsuccessful requests
                jedis.set(String.valueOf(i), json.toString());
                System.out.println("Current id = " + i);
                System.out.println(json.toPrettyString());
                i++;
            }

        }
        catch (GeneralSecurityException | IOException ex)
        {
            //TODO: add pushing logs to kibana or etc..
            ex.printStackTrace();
        }
    }
}
