package org.example;

import com.fasterxml.jackson.databind.JsonNode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import redis.clients.jedis.HostAndPort;
import redis.clients.jedis.JedisPooled;

import java.io.IOException;

@Component
public class LoadGameTask implements Runnable
{
    @Autowired
    private RedisService redisService;

    @Override
    public void run()
    {
        JsonNode json;

        int i = 0;
        while (true)
        {
            if (SteamPriceParser.gameCodeList.get(i) == null)
            {
                break;
            }
            if (!SteamPriceParser.gameCodeList.get(i))
            {
                //Block item
                SteamPriceParser.gameCodeList.put(i, true);
                break;
            }
        }

        try (JedisPooled jedis = new JedisPooled(new HostAndPort(SteamConstants.REDIS_HOST, 6380), redisService.prepareRedisConfig()))
        {
            try
            {
                json = redisService.loadGameJson(String.format(SteamConstants.GAME_DETAILS_API_TEMPLATE, i, "KZ"));
            }
            catch (IOException e)
            {
                //TODO: add pushing logs to kibana or etc..
                e.printStackTrace();
                unblockItem(i);
                return;

            }
            //TODO: add filter for successful and unsuccessful requests
            jedis.set(String.valueOf(i), json.toString());
            System.out.println("Current id = " + i);
            System.out.println(json.toPrettyString());
            removeItem(i);

        }
        catch (Exception ex)
        {
            //TODO: add pushing logs to kibana or etc..
            ex.printStackTrace();
        }
    }

    private synchronized void unblockItem(int i)
    {
        SteamPriceParser.gameCodeList.put(i, false);
    }

    private synchronized void removeItem(int i)
    {
        SteamPriceParser.gameCodeList.remove(i);
    }
}
